"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.autoCssModules = exports.autoModulesTransformer = void 0;
const path_1 = require("path");
const autoModulesTransformer_1 = require("./autoModulesTransformer");
Object.defineProperty(exports, "autoModulesTransformer", { enumerable: true, get: function () { return autoModulesTransformer_1.autoModulesTransformer; } });
const autoCssModules = (opts = {}) => {
    return {
        name: 'auto-css-modules',
        setup(build) {
            build.onLoad({ filter: opts.filter || /\.([tj]sx?)$/ }, (args) => __awaiter(this, void 0, void 0, function* () {
                let filePath = args.path;
                if (opts.ignore) {
                    if ('function' === typeof opts.ignore && opts.ignore(filePath)) {
                        return null;
                    }
                    if (opts.ignore instanceof RegExp && opts.ignore.test(filePath)) {
                        return null;
                    }
                    throw new Error('ignore option must be a function or a regexp');
                }
                const code = yield (0, autoModulesTransformer_1.autoModulesTransformer)(filePath, {
                    flag: opts.flag,
                    sourcemap: !!build.initialOptions.sourcemap,
                    sourceRoot: build.initialOptions.sourceRoot,
                });
                if (typeof code === 'string') {
                    const ext = (0, path_1.extname)(filePath);
                    return { contents: code, loader: ext.substring(1) };
                }
                return null;
            }));
        },
    };
};
exports.autoCssModules = autoCssModules;
